#include <bits/stdc++.h>
#define int long long

#define MULTITEST true

using namespace std;

bool _solve () {
    int N;
    cin >> N;

    string buffer;
    cin >> buffer;

    vector<int> w_first;
    vector<int> w_second;
    vector<int> r_first;
    vector<int> r_second;

    for (int i = 0; i < N; i ++) {
        if (buffer[i] == 'W') w_first.push_back(i);
        else r_first.push_back(i);
    }
    for (int i = 0; i < N; i ++) {
        if (buffer[i + N] == 'W') w_second.push_back(i + N);
        else r_second.push_back(i + N);
    }

    int w = w_first.size();
    if ((w % 2) != 0) return false;

    int r = w >> 1;
    for (int i = 0; i < r; i ++) {
        if(buffer[i] != 'W') return false;
        if(buffer[2 * N - 1 - i] != 'R') return false;
    }

    return true;
}

void solve () {
    bool r = _solve();

    if (r) cout << "YES\n";
    else cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.precision(30);
    
    int T = 1;
    if (MULTITEST) cin >> T;

    for (int t = 0; t < T; t ++)
        solve();
}